#include<bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n,m,k,a,b;
    cin >> n >> m >> k;
    bool floyd[n+1][n+1];
    for(int i = 0; i < n+1; i++) {
        for(int j = 0; j < n+1; j++) {
            floyd[i][j] = false;
            if(i == j) {
                floyd[i][j] = true;
            }
        }
    }
    for(int i = 0; i < m; i++) {
        cin >> a >> b;
        floyd[a][b] = true;
    }
    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= n; j++) {
            for(int p = 1; p <= n; p++) {
                if(floyd[j][i] && floyd[i][p]) {
                    floyd[j][p] = true;
                }
            }
        }
    }
    vector<int> haha(n+1);
    for(int i = 0; i < k; i++) {
        cin >> a >> b;
        for(int j = 1; j <= n; j++) {
            if(floyd[a][j] && floyd[j][b]) {
                haha[j]++;
            }
        }
    }
    vector<int> bruh(0);
    for(int i = 1; i <= n; i++) {
        if(haha[i] == k) {
            bruh.push_back(i);
        }
    }
    cout << bruh.size() << endl;
    for(int i = 0; i < bruh.size(); i++) {
        cout << bruh[i] << " ";
    }
    return 0;
}
